{    var   : }
{ N, ALFA, BETA, GAM }
Unit MNBBR_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNB6R_p;

procedure MNBBR(var N :Integer; NMP1 :Integer; var ITMAX :Integer;
                ITMT :Integer; var ALFA :Real; var BETA :Real;
                var GAM :Real; ACC :Real; A :Real;
                var XYZ :Array of Real; var XX :Array of Real;
                var VEC :Array of Real; var FF :Real;
                var MAXK :Integer; var MAXT :Integer; FUN :Proc_F1_MN;
                FUNT :Proc_F1_MN; var IERR :Integer);

implementation

procedure MNBBR(var N :Integer; NMP1 :Integer; var ITMAX :Integer;
                ITMT :Integer; var ALFA :Real; var BETA :Real;
                var GAM :Real; ACC :Real; A :Real;
                var XYZ :Array of Real; var XX :Array of Real;
                var VEC :Array of Real; var FF :Real;
                var MAXK :Integer; var MAXT :Integer; FUN :Proc_F1_MN;
                FUNT :Proc_F1_MN; var IERR :Integer);
var
L,NP1,NP2,KK,KOUN,MAXT1,ITR,KOUNT,ITM,J,I,IND,K,IER1 :Integer;
Q,P,EPS1,R,RR,FIK,AA,AT,TX,ZHI,SUM,ZCEN,EPS,ZREF,ZCON,ZEX,FTE,XT,
   FE :Real;
label
_90,_100,_120,_150,_154,_155,_162,_163,_164,_165,_170,_171,_174,_175,
_180,_182,_185,_190,_195,_200,_208,_210,_215,_220,_221,_222,_224,_225,
_240,_245,_250,_255,_260,_261,_270,_280,_300,_310,_1000;
begin
L := 0;
NP1 := N+1;
NP2 := 2*N+2;
KK := 2*N+1;
KOUN := 0;
MAXT1 := MAXT;
ITR := 0;
KOUNT := 0;
Q := (A/(N*(Power(2.0,0.5))))*(Power(N+1.0,0.5)-1.0);
P := (A/(N*(Power(2.0,0.5))))*(Power(N+1,0.5)+N-1.0);
EPS1 := 1.E-08;
R := N-NMP1;
RR := NMP1;
FIK := 2.0*A*(R+2.0);
ITM := ITMT;
AA := 1.E-08;
AT := 0.05*FIK;
FUNT(XX,TX,FTE);
if ( TX <= FIK ) 
 then goto _90;
MNB6R(N,NP1,ITM,ALFA,BETA,GAM,AA,
     AT,XYZ[0+(NP1-1)*NMP1],VEC[0+4*N],XYZ[0+(NP2-1)*NMP1],
     VEC[0+5*N],VEC[0+6*N],VEC[0+7*N],
     XX,XT,MAXT1,FUNT,IER1);
KOUN := KOUN+MAXT1;
MAXT1 := MAXT;
ITM := ITMT;
_90:
{ --------- }
{    OCTPOEHE HAAHOO CMEKCA }

for J:=1 to N do
 begin
_100:
  XYZ[0+(J-1)*NMP1] := XX[J-1];
 end;
for I:=2 to NMP1 do
 begin
  for J:=1 to N do
   begin
    XYZ[(I-1)+(J-1)*NMP1] := XYZ[0+(J-1)*NMP1]+Q;
    if ( I-1 = J ) 
     then XYZ[(I-1)+(J-1)*NMP1] := XYZ[0+(J-1)*NMP1]+P;
_120:
   end;
 end;
{ --------- }
{    HAAO TEPA }

_150:
for I:=1 to NMP1 do
 begin
  if ( I = L ) 
   then goto _155;
  for J:=1 to N do
   begin
_154:
    XX[J-1] := XYZ[(I-1)+(J-1)*NMP1];
   end;
  FUN(XX,XYZ[(I-1)+(KK-1)*NMP1],FE);
  KOUNT := KOUNT+1;
_155:
 end;
_162:
ITR := ITR+1;
IND := 0;
if ( ITR > ITMAX ) 
 then goto _270;
_163:
if ( KOUNT > MAXK ) 
 then goto _280;
ZHI := XYZ[0+(KK-1)*NMP1];
FF := XYZ[0+(KK-1)*NMP1];
K := 1;
L := 1;
for I:=2 to NMP1 do
 begin
  if ( ZHI >= XYZ[(I-1)+(KK-1)*NMP1] ) 
   then goto _164;
  ZHI := XYZ[(I-1)+(KK-1)*NMP1];
  K := I;
_164:
  if ( FF <= XYZ[(I-1)+(KK-1)*NMP1] ) 
   then goto _165;
  FF := XYZ[(I-1)+(KK-1)*NMP1];
  L := I;
_165:
 end;
if ( IND = 1 ) 
 then goto _174;
for J:=1 to N do
 begin
_170:
  XX[J-1] := XYZ[(L-1)+(J-1)*NMP1];
 end;
FUNT(XX,TX,FTE);
if ( TX <= FIK ) 
 then goto _174;
MNB6R(N,NP1,ITM,ALFA,BETA,GAM,AA,AT,
     XYZ[0+(NP1-1)*NMP1],VEC[0+4*N],XYZ[0+(NP2-1)*NMP1],
     VEC[0+5*N],VEC[0+6*N],VEC[0+7*N],
     XX,TX,MAXT,FUNT,IER1);
ITM := ITMT;
for J:=1 to N do
 begin
_171:
  XYZ[(L-1)+(J-1)*NMP1] := XX[J-1];
 end;
FUN(XX,XYZ[(L-1)+(KK-1)*NMP1],FE);
KOUNT := KOUNT+1;
IND := 1;
goto _163;
{ --------- }
{    EHTPO }

_174:
for J:=1 to N do
 begin
  SUM := 0.0;
  for I:=1 to NMP1 do
   begin
    if ( K = I ) 
     then goto _175;
    SUM := SUM+XYZ[(I-1)+(J-1)*NMP1];
_175:
   end;
_180:
  VEC[(J-1)+0*N] := SUM/(RR-1.0);
 end;
SUM := 0.0;
for I:=1 to NMP1 do
 begin
  for J:=1 to N do
   begin
_182:
    SUM := SUM+IntPower(XYZ[(I-1)+(J-1)*NMP1]-VEC[(J-1)+0*N],2);
   end;
 end;
SUM := Sqrt(SUM)*(R+2.0)/RR;
if ( SUM < FIK ) 
 then FIK := SUM;
if ( FIK < EPS1 ) 
 then goto _261;
FUN(VEC[0+0*N],ZCEN,FE);
KOUNT := KOUNT+1;
SUM := 0.0;
for I:=1 to NMP1 do
 begin
  if ( K = I )
   then goto _185;
  SUM := SUM+IntPower(XYZ[(I-1)+(KK-1)*NMP1]-ZCEN,2) /(RR-1.0);
_185:
 end;
EPS := Sqrt(SUM);
if ( EPS < ACC ) 
 then goto _261;
{ --------- }
{    OTPAEHE }

for J:=1 to N do
 begin
_190:
  VEC[(J-1)+1*N] := VEC[(J-1)+0*N]+ALFA*(VEC[(J-1)+0*N]-XYZ[(K-1)+(J-1)*NMP1]);
 end;
FUNT(VEC[0+1*N],TX,FTE);
if ( TX <= FIK ) 
 then goto _195;
MNB6R(N,NP1,ITM,ALFA,BETA,GAM,AA,AT,
     XYZ[0+(NP1-1)*NMP1],VEC[0+4*N],XYZ[0+(NP2-1)*NMP1],
     VEC[0+5*N],VEC[0+6*N],VEC[0+7*N],
     VEC[0+1*N],TX,MAXT1,FUNT,IER1);
KOUN := KOUN+MAXT1;
MAXT1 := MAXT;
ITM := ITMT;
_195:
FUN(VEC[0+1*N],ZREF,FE);
KOUNT := KOUNT+1;
if ( ZREF <= XYZ[(L-1)+(KK-1)*NMP1] ) 
 then goto _240;
for I:=1 to NMP1 do
 begin
  if ( ZREF < XYZ[(I-1)+(KK-1)*NMP1] ) and ( I <> K ) 
   then goto _208;
_200:
 end;
goto _215;
_208:
for J:=1 to N do
 begin
_210:
  XYZ[(K-1)+(J-1)*NMP1] := VEC[(J-1)+1*N];
 end;
XYZ[(K-1)+(KK-1)*NMP1] := ZREF;
goto _162;
{ --------- }
{    CATE }

_215:
for J:=1 to N do
 begin
_220:
  VEC[(J-1)+2*N] := VEC[(J-1)+0*N]+BETA*(XYZ[(K-1)+(J-1)*NMP1]-VEC[(J-1)+0*N]);
 end;
FUNT(VEC[0+2*N],TX,FTE);
if ( TX <= FIK ) 
 then goto _221;
MNB6R(N,NP1,ITM,ALFA,BETA,GAM,AA,AT,
     XYZ[0+(NP1-1)*NMP1],VEC[0+4*N],XYZ[0+(NP2-1)*NMP1],
     VEC[0+5*N],VEC[0+6*N],VEC[0+7*N],
     VEC[0+2*N],TX,MAXT1,FUNT,IER1);
KOUN := KOUN+MAXT1;
MAXT1 := MAXT;
ITM := ITMT;
_221:
FUN(VEC[0+2*N],ZCON,FE);
KOUNT := KOUNT+1;
if ( ZCON >= XYZ[(K-1)+(KK-1)*NMP1] ) 
 then goto _224;
for J:=1 to N do
 begin
_222:
  XYZ[(K-1)+(J-1)*NMP1] := VEC[(J-1)+2*N];
 end;
XYZ[(K-1)+(KK-1)*NMP1] := ZCON;
goto _162;
{ --------- }
{    PEYK }

_224:
for J:=1 to N do
 begin
  for I:=1 to NMP1 do
   begin
_225:
    XYZ[(I-1)+(J-1)*NMP1] := (XYZ[(I-1)+(J-1)*NMP1]+XYZ[(L-1)+(J-1)*NMP1])/2.0;
   end;
 end;
goto _150;
{ --------- }
{    PACTEHE }

_240:
for J:=1 to N do
 begin
_245:
  VEC[(J-1)+3*N] := VEC[(J-1)+0*N]+GAM*(VEC[(J-1)+1*N]-VEC[(J-1)+0*N]);
 end;
FUNT(VEC[0+3*N],TX,FTE);
if ( TX <= FIK )
 then goto _250;
MNB6R(N,NP1,ITM,ALFA,BETA,GAM,AA,AT,
     XYZ[0+(NP1-1)*NMP1],VEC[0+4*N],XYZ[0+(NP2-1)*NMP1],
     VEC[0+5*N],VEC[0+6*N],VEC[0+7*N],
     VEC[0+3*N],TX,MAXT1,FUNT,IER1);
KOUN := KOUN+MAXT1;
MAXT1 := MAXT;
ITM := ITMT;
_250:
FUN(VEC[0+3*N],ZEX,FE);
KOUNT := KOUNT+1;
if ( ZEX < XYZ[(L-1)+(KK-1)*NMP1] ) 
 then goto _255;
goto _208;
_255:
for J:=1 to N do
 begin
_260:
  XYZ[(K-1)+(J-1)*NMP1] := VEC[(J-1)+3*N];
 end;
XYZ[(K-1)+(KK-1)*NMP1] := ZEX;
goto _162;
{ --------- }
{    B  X O  }

_261:
IERR := 1;
goto _300;
_270:
IERR := 65;
ITR := ITR-1;
goto _300;
_280:
IERR := 66;
_300:
for J:=1 to N do
 begin
_310:
  XX[J-1] := XYZ[(L-1)+(J-1)*NMP1];
 end;
MAXK := KOUNT;
ITMAX := ITR;
MAXT := KOUN;
_1000:
end;

end.
